<template>
    <div>
        <div class="form-group form-inline discount-group bordered-style-block">
            <div class="full-width">
                <div class="form-title">
                    <b>Logo</b>
                </div>
                <div><b>Logo image</b></div>
                <div class="dropzone-container">
                    <VueDropzone
                        id="dropzone"
                        ref="dropzone"
                        class="dz-clickable text-center"
                        :options="dropzoneOptions"
                        :destroy-dropzone="false"
                        @vdropzone-removed-file="removeFile"
                        @vdropzone-mounted="setFile"
                        @vdropzone-success="updatePreview"
                    >
                        <div class="dz-default dz-message" />
                    </VueDropzone>
                </div>
            </div>
        </div>
        <div class="form-group discount-group bordered-style-block">
            <div class="full-width">
                <div class="form-title">
                    <b>Popup Content</b>
                </div>
                <div class="row">
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="title-color">
                                Header text color
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="title-color"
                                    v-model="design.headerText.color.hex"
                                    data-vv-as="Header Text Color"
                                    name="colors[header_text]"
                                    type="text"
                                    class="my-input"
                                >
                                <button
                                    :style="{background: design.headerText.color.hex}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker(design.headerText)"
                                />
                                <div
                                    v-if="design.headerText.active"
                                    class="chrome-picker"
                                >
                                    <chrome v-model="design.headerText.color" />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="title-color">
                                Body text color
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="body-color"
                                    v-model="data.colors.body_text"
                                    data-vv-as=" Body Text Color"
                                    name="colors[body_text]"
                                    type="text"
                                    class="my-input"
                                >
                                <button
                                    :style="{background: data.colors.body_text}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker(design.bodyText)"
                                />

                                <div
                                    v-if="design.bodyText.active"
                                    class="chrome-picker"
                                >
                                    <chrome v-model="design.bodyText.color" />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="title-color">
                                Window Background
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="window-color"
                                    v-model="design.windowBackgroundColor.color.hex"
                                    data-vv-as="Window Background"
                                    name="colors[window_background_color]"
                                    type="text"
                                    class="my-input"
                                >
                                <button
                                    :style="{background: design.windowBackgroundColor.color.hex}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker(design.windowBackgroundColor)"
                                />

                                <div
                                    v-if="design.windowBackgroundColor.active"
                                    class="chrome-picker"
                                >
                                    <chrome v-model="design.windowBackgroundColor.color" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-6">
                        <div class="form-group">
                            <div class="title-color">
                                Decline notifications text color
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="highlighted-text-color"
                                    v-model="design.disallowText.color.hex"
                                    data-vv-as="Decline notifications text color"
                                    name="colors[disallow_text]"
                                    type="text"
                                    class="my-input"
                                >
                                <button
                                    :style="{background: design.disallowText.color.hex}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker(design.disallowText)"
                                />

                                <div
                                    v-if="design.disallowText.active"
                                    class="chrome-picker"
                                >
                                    <chrome v-model="design.disallowText.color" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group discount-group bordered-style-block">
            <div class="full-width">
                <div class="form-title">
                    <b>Call To Action</b>
                </div>
                <div class="row">
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="title-color">
                                Allow Notifications Button Background
                                Color
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="notif-button-color"
                                    v-model="design.allowBackground.color.hex"
                                    data-vv-as="Header Text Color"
                                    name="colors[allow_background]"
                                    type="text"
                                    class="my-input"
                                >
                                <button
                                    :style="{background: design.allowBackground.color.hex}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker(design.allowBackground)"
                                />
                                <div
                                    v-if="design.allowBackground.active"
                                    class="chrome-picker"
                                >
                                    <chrome v-model="design.allowBackground.color" />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="title-color">
                                Allow Notifications Button Text
                                Color
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="notif-text-color"
                                    v-model="design.allowColor.color.hex"
                                    data-vv-as="Allow Notifications Button Text Color"
                                    name="colors[allow_color]"
                                    type="text"
                                    class="my-input"
                                >
                                <button
                                    :style="{background: design.allowColor.color.hex}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker(design.allowColor)"
                                />

                                <div
                                    v-if="design.allowColor.active"
                                    class="chrome-picker"
                                >
                                    <chrome v-model="design.allowColor.color" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import VueDropzone from "vue2-dropzone";
import 'vue2-dropzone/dist/vue2Dropzone.min.css';
import { Chrome} from 'vue-color'
import headers from '../../../../helpers/authHeader'
import link from '../../../../helpers/backLink'

export default {
    name: "DesignEditor",
    components: {
        VueDropzone,
        Chrome
    },
    props: ['design', 'notif'],
    mixins: [headers, link],
    data() {
        return {
            dropzoneOptions: {
                url: this.getSegment()  + '/push/growth/popup/picture/',
                headers: {Authorization: `Bearer ${$cookies.get('userToken')}` },
                thumbnailWidth: 120,
                thumbnailHeight: 120,
                maxFiles: 1,
                maxFilesize: 0.512,
                addRemoveLinks: true,
                acceptedFiles: "image/jpeg,image/png",
                dictRemoveFile: 'Remove',
                dictDefaultMessage: '<div style="border: 1px dotted rgba(138, 135, 135, 0.36);\n' +
                    '    display: inline-block;\n' +
                    '    padding: 10px 20px 10px 40px;">' +
                    '<span class="mb-20">' +
                    '<img style="max-width:40px; margin-left: -20px;margin-right: 20px" src="/images/cart-icon-new.png">' +
                    '</span><b>Upload your logo image</b></div>'
            },

        }
    },
    methods: {
        showPicker(val) {
            this.hidePicker();
            document.addEventListener('click', this.documentClick);

            val.active = true;
        },
        documentClick(e) {
            if (e.target.className.indexOf('btn-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hidePicker()
            }
        },
        hidePicker() {
            document.removeEventListener('click', this.documentClick);
            this.design.headerText.active = false;
            this.design.bodyText.active = false;
            this.design.disallowText.active = false;
            this.design.allowBackground.active = false;
            this.design.allowColor.active = false;
            this.design.windowBackgroundColor.active = false;
        },
        removeFile() {
            axios.delete(this.getSegment()+'/push/growth/popup/picture/', this.getUserHeader())
                .then(response => {
                    this.notif.logo = null;
                });
        },
        setFile() {
            let file = {size: 0, name: "Icon", type: "image/jpeg"};
            let url = this.notif.logo;
            if (url) {
                this.$refs.dropzone.manuallyAddFile(file, url);
            }
        },
        updatePreview(file, response) {
            this.notif.logo = response;
        },
    }
}
</script>

<style scoped lang="scss">

.my-input {
    max-width: 100px !important;
}

</style>
